package strategy

// CheckoutStrategy enumerates the strategies for checking out files from the cache
type CheckoutStrategy int

const (
	// LinkStrategy creates read-only links to files in the cache (prefers hard links to symbolic)
	LinkStrategy CheckoutStrategy = iota
	// CopyStrategy creates copies of files in the cache
	CopyStrategy
)

func (strat CheckoutStrategy) String() string {
	return [...]string{"LinkStrategy", "CopyStrategy"}[strat]
}
